apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ diaspora_name }}
    backups.opsperator.io/service: backups-{{ diaspora_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ diaspora_name }}
  name: {{ diaspora_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ diaspora_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ diaspora_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ diaspora_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    recreateParams:
      timeoutSeconds: 3600
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ diaspora_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ diaspora_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ diaspora_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: COUNTRY
          value: {{ diaspora_country }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
{% if matomo_api_public is defined %}
        - name: PIWKI_SITE_ID
          value: "{{ diaspora_matomo_site_id }}"
        - name: PIWKI_HOST
          value: {{ matomo_api_public | urlsplit('hostname') }}
{% else %}
        - name: MATOMO_SITE_ID
          value: ""
        - name: MATOMO_URL
          value: ""
{% endif %}
        - name: MYSQL_DB
{% if diaspora_db_type == 'percona' %}
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ dspc_name }}
        - name: MYSQL_HOST
          value: {{ dspc_name }}-client
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ dspc_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ dspc_name }}
{% elif diaspora_db_type in [ 'mariadb', 'mysql' ] %}
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ dsms_name }}
        - name: MYSQL_HOST
          value: {{ dsms_name }}
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ dsms_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ dsms_name }}
{% else %}
          value: ""
        - name: MYSQL_HOST
          value: ""
        - name: MYSQL_PASS
          value: ""
        - name: MYSQL_PORT
          value: ""
{% endif %}
        - name: POSTGRES_DB
{% if diaspora_db_type == 'postgres' %}
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ dspg_name }}
        - name: POSTGRES_HOST
          value: {{ dspg_name }}
        - name: POSTGRES_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ dspg_name }}
        - name: POSTGRES_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ dspg_name }}
{% else %}
        - name: POSTGRES_DB
          value: ""
        - name: POSTGRES_HOST
          value: ""
        - name: POSTGRES_PASS
          value: ""
        - name: POSTGRES_USER
          value: ""
{% endif %}
        - name: REDIS_HOST
          value: {{ cache_name }}
        - name: SITE_FQDN
          value: diaspora.{{ root_domain }}
        - name: SITE_NAME
          value: {{ diaspora_site_name }}
        - name: SK_WORKERS
          value: "{{ diaspora_sidekiq_workers }}"
        - name: SMTP_HELO
          valueFrom:
            fieldRef:
              fieldPath: spec.nodeName
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_PROTO
          value: smtp
        - name: SMTP_STARTTLS
          value: "true"
        - name: SMTP_VERIFY
          value: none
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtps
        - name: SMTP_STARTTLS
          value: "false"
        - name: SMTP_VERIFY
          value: peer
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtp
        - name: SMTP_STARTTLS
          value: "false"
        - name: SMTP_VERIFY
          value: none
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_PROTO
          value: ""
        - name: SMTP_STARTTLS
          value: ""
        - name: SMTP_VERIFY
          value: none
{% endif %}
        - name: TZ
          value: {{ timezone }}
        - name: UC_WORKERS
          value: "{{ diaspora_unicorn_workers }}"
{% if do_triggers == False or (opsimages | json_query("[?name=='diaspora'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='diaspora'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 118
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            httpHeaders:
            - name: Host
              value: diaspora.{{ root_domain }}
            - name: X-Forwarded-Proto
              value: https
            path: /podmin
            port: 3000
          initialDelaySeconds: 120
          periodSeconds: 30
          timeoutSeconds: 5
        name: diaspora
        ports:
        - containerPort: 3000
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
              value: diaspora.{{ root_domain }}
            - name: X-Forwarded-Proto
              value: https
            path: /podmin
            port: 3000
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
{% if 0 == 1 %}
            cpu: "{{ diaspora_cpu_limit }}"
pod takes around 50 minutes to start (liveness OK), when cpu limit=200m
{% endif %}
            memory: "{{ diaspora_memory_limit }}"
          requests:
            cpu: "{{ diaspora_cpu_request }}"
            memory: "{{ diaspora_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 118
          initialDelaySeconds: 120
          periodSeconds: 30
          tcpSocket:
            port: 3000
{% endif %}
        volumeMounts:
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /diaspora/public/uploads
          name: data
{% if do_backups %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if (rwx_storage | default(False) and rwx_needs_fsgroup | default(False)) or (rwx_storage is not defined and rwo_needs_fsgroup | default(False)) %}
      securityContext:
{% if rwx_storage | default(False) and rwx_needs_fsgroup | default(False) %}
        fsGroup: {{ rwx_needs_fsgroup }}
{% elif rwx_storage is not defined and rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ diaspora_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: data
        persistentVolumeClaim:
          claimName: {{ diaspora_name }}
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ diaspora_name }}
      - emptyDir: {}
        name: tmp
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='diaspora'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - diaspora
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='diaspora'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
